/*** GRAF.C - Para compilar digite TCC -ml graf.c graphics.lib ***/

#include "graficos.c"
#include "escondid.c"
#include "fx.c"

char ExpressaoNumericaStr1[MAX_CAR_EXP], ExpressaoNumericaStr2[MAX_CAR_EXP],
     ExpressaoNumericaStr3[MAX_CAR_EXP];

float f1(float u, float v) {

  char ustr[MAX_CAR_VAR], vstr[MAX_CAR_VAR], copia[MAX_CAR_EXP];

  strcpy(copia, ExpressaoNumericaStr1);
  sprintf(ustr, "(%f)", u);
  sprintf(vstr, "(%f)", v);
  SubstituiIDelimitado(copia, var1, ustr, delimitadores);
  SubstituiIDelimitado(copia, var2, vstr, delimitadores);
  return Calcula_F(copia);
}

float f2(float u, float v) {

  char ustr[MAX_CAR_VAR], vstr[MAX_CAR_VAR], copia[MAX_CAR_EXP];

  strcpy(copia, ExpressaoNumericaStr2);
  sprintf(ustr, "(%f)", u);
  sprintf(vstr, "(%f)", v);
  SubstituiIDelimitado(copia, var1, ustr, delimitadores);
  SubstituiIDelimitado(copia, var2, vstr, delimitadores);
  return Calcula_F(copia);
}

float f3(float u, float v) {

  char ustr[MAX_CAR_VAR], vstr[MAX_CAR_VAR], copia[MAX_CAR_EXP];

  strcpy(copia, ExpressaoNumericaStr3);
  sprintf(ustr, "(%f)", u);
  sprintf(vstr, "(%f)", v);
  SubstituiIDelimitado(copia, var1, ustr, delimitadores);
  SubstituiIDelimitado(copia, var2, vstr, delimitadores);
  return Calcula_F(copia);
}

void main(void) {
  char ch;
  float umin = -3, umax = 3, vmin = -3, vmax = 3;
  int cor_f1 = BLACK, cor_f2 = BLACK, cor_int1 = RED, cor_int2 = RED,
      cor_int3 = CYAN, cor_int4 = CYAN, padrao1 = 255, padrao2 = 255;
  char *Arquivo = "ARQ.DAT";
  float xx1, xx2, yy1, yy2, zz1, zz2;
  int col, linha, construir = VERDADEIRO;

  printf("\n\nͻ");
  printf(  "\n  CONSTRUAO  DE GRAFICOS  DE  SUPERFICIES  ");
  printf(  "\n  F(u, v) = (f1(u, v), f2(u, v), f3(u, v))  ");
  printf(  "\nͼ\n");
  strcpy(var1, "u");
  strcpy(var2, "v");

  printf("\n%c Operadores vlidos:  +  -  *  /  ^\n", 254);
  printf("\n%c Funoes vlidas: SEN,  COS,  TG,  ARCSEN,  ARCCOS,  ARCTG,  LN,", 254);
  printf("\n                   EXP,  SENH,  COSH,  TGH,   INT,  ROUND,  SQRT,");
  printf("\n                   SQR,  ABS,  SIGN\n");
  printf("\n%c Sao consideradas idnticas as funoes SIN e SEN, TAN e TG, LOG e LN\n\n", 254);

  printf("\nf1(%s, %s) = ", var1, var2); gets(ExpressaoNumericaStr1);
  if (!CompilaExpr(ExpressaoNumericaStr1)) {
    printf("\n\nERRO: %s\n\n", MsgErro[Erro]);
    return;
  }
  printf("f2(%s, %s) = ", var1, var2); gets(ExpressaoNumericaStr2);
  if (!CompilaExpr(ExpressaoNumericaStr2)) {
    printf("\n\nERRO: %s\n\n", MsgErro[Erro]);
    return;
  }
  printf("f3(%s, %s) = ", var1, var2); gets(ExpressaoNumericaStr3);
  if (!CompilaExpr(ExpressaoNumericaStr3)) {
    printf("\n\nERRO: %s\n\n", MsgErro[Erro]);
    return;
  }

  printf("\nA posiao atual do observador   (%3.1f, %3.1f, %3.1f)", o1, o2, o3);
  printf("\nQuer alterar essa posiao? (s/n) "); ch = getche();
  if (toupper(ch) == 'S') {
    printf("\nFornea a nova posiao (sem parnteses e sem vrgulas): ");
    scanf("%f %f %f", &o1, &o2, &o3);
  }
  else printf("\n");

  printf("\n%s minimo = ", var1); scanf("%f", &umin);
  printf("%s maximo = ", var1); scanf("%f", &umax);
  printf("%s minimo = ", var2); scanf("%f", &vmin);
  printf("%s maximo = ", var2); scanf("%f", &vmax);

  printf("\nQuantas subdivisoes do intervalo [%5.2f, %5.2f] da variavel %s? ",
	 umin, umax, var1); scanf("%f", &nu);
  if (nu < 5 || nu > 200) nu = 30;
  printf("Quantas subdivisoes do intervalo [%5.2f, %5.2f] da variavel %s? ",
	 vmin, vmax, var2); scanf("%f", &nv);
  if (nv < 5 || nv > 200) nv = 30;

  IniciaModoGrafico();
  A = getmaxx()/2, B = getmaxy()/2, TAM = 70;
  inc = 0.1;
  o1 = 2, o2 = 1, o3 = 0.7;
  DeterminaPlanoDeProjecao();
  restorecrtmode();
  printf("\n");
  col = wherex(), linha = wherey();
  printf("> Ajustando o tamanho do grafico...");
  AjustaTAM(f1, f2, f3, umin, umax, vmin, vmax);
  gotoxy(col, linha); clreol();
  printf("%c Tamanho do grafico ajustado para %5.1f\n", 254, TAM);
  linha++;

  do {
  if (construir)
  DesenhaSuperficieEsc(f1, f2, f3, umin, umax, vmin, vmax, &xx1, &xx2,
  &yy1, &yy2, &zz1, &zz2, cor_f1, cor_f2, cor_int1, cor_int2, cor_int3,
  cor_int4, padrao1, padrao2, Arquivo, YELLOW);
  construir = FALSO;
  ch = getch();

  if (ch == 0) {
    ch = getch();
    construir = VERDADEIRO;
    switch (ch) {
      case TeclaF1: cor_int1 = (cor_int1 + 1) % 16; break;
      case TeclaF2: cor_int2 = (cor_int2 + 1) % 16; break;
      case TeclaF3: cor_int3 = (cor_int3 + 1) % 16; break;
      case TeclaF4: cor_int4 = (cor_int4 + 1) % 16; break;
      case TeclaF5: cor_f1 = (cor_f1 + 1) % 16; break;
      case TeclaF6: cor_f2 = (cor_f2 + 1) % 16; break;
      case TeclaF7: padrao1 = (padrao1 + 1) % 256; break;
      case TeclaF8: padrao2 = (padrao2 + 1) % 256; break;
      case SetaPCima: o3 += 1; break;
      case SetaPBaixo: o3 -= 1; break;
      case SetaPEsquerda: o1 -= 1; break;
      case SetaPDireita: o1 += 1; break;
      case PgUp: if (TAM < 150) TAM += 20; break;
      case PgDn: if (TAM > 20) TAM -= 20; break;
      default: construir = FALSO;
    }
    }
    if (construir) cleardevice();
  } while (ch != ESC);

  closegraph();
}
